A
Date: 2:24 pm  Tue Aug 4, 1992         Number : 298 of 300
From: Stefan Danes                     Base   : Pascal Echo
To  : Gerald Gutierrez                 Refer #: None
Subj: SB Port !                        Replies: None
Stat: Sent                             Origin : 31 Jul 92  12:20:00

Hello!

 > Does anyone know how to go about determining the base
 > port of a SB/SBPro ? Also .. are the 'other' ports (
 > ie: reset/write/read/data ports ) simply
 > offsets relative to the base port ?

Yes, Here's a BASM routine to do the job.

Function DetectSB returns the SB Base Address
AX = 0FFFFh if no soundblaster found
Else: AX = Sound Blaster Base Address

Function GetSBVersion returns the revision of the DSP chip... (0301h for my
SB-PRO)

Base + 00h = Left  FM Cmd & Status  (R/W) (Pro)
Base + 01h = Left  FM Data          (WO)  (Pro)
Base + 02h = Right FM Cmd & Data    (R/W) (Pro)
Base + 03h = Right FM Data          (WO)  (Pro)
Base + 04h = Mixer Chip Register    (WO)  (Pro)
Base + 05h = Mixer Chip Data        (R/W) (Pro)
Base + 06h = DSP Reset              (WO)
Base + 08h = Mono FM Cmd & Status   (R/W) (Also 388h)
Base + 09h = Mono FM Data           (WO)  (Also 389h)
Base + 0Ah = DSP Read               (RO)
Base + 0Ch = DSP Cmd/Data/Stat      (R/W)
Base + 0Eh = DSP Data Available (b7)(RO)
Base + 10h = CD-ROM Cmd & Data      (R/W) (Pro)
Base + 11h = CD-ROM Status          (RO)  (Pro)
Base + 12h = CD-ROM Reset           (WO)  (Pro)
Base + 13h = CD-ROM Access          (WO)  (Pro)

Function DetectSB:Word; Assembler;
Asm
                mov dx,$210
@SearchNext:    add dl,6
                mov al,1
                out dx,al
                dec al
                out dx,al
                add dl,$E-6
                mov cx,200
@WaitCMD:       in al,dx
                shl al,1
                jc @CMD_Ready
                loop @WaitCMD
@DoNext:        and dl,$F0
                add dl,$10
                cmp dl,$60
                jbe @SearchNext
                mov ax,-1
                jmp @SBNotFound

@CMD_Ready:     mov cx,200
                sub dl,$E-$A
@WaitDSPReset:  in al,dx
                cmp al,$AA
                loopnz @WaitDSPReset
                jcxz @DoNext
                and dl,$F0
                mov ax,dx
@SBNotFound:
End;


Function GetSBVersion:Word; Assembler;
Asm
                mov dx,SBBase
                add dl,$C
                mov al,$E1
                out dx,al
                add dl,$E-$C
                mov cx,200
@WaitCMD1:      in al,dx
                shl al,1
                jc @CMD_Ready1
                loop @WaitCMD1
                jmp @Quit
@CMD_Ready1:    sub dl,$E-$A
                in al,dx
                mov bh,al
                add dl,$E-$A
                mov cx,200
@WaitCMD2:      in al,dx
                shl al,1
                jc @CMD_Ready2
                loop @WaitCMD2
                jmp @Quit
@CMD_Ready2:    sub dl,$E-$A
                in al,dx
                mov bl,al
                mov ax,bx
@Quit:

Greetz From Sunny Eindhoven (Hollland), Stefan

---
 * Origin: The Cheetah can't hide, he's always spotted! (2:284/108.1)



[Pascal Echo]
[298] Read (1-300, <CR>, ? = HELP) >> A
Date: 2:10 am  Thu Aug 6, 1992         Number : 336 of 349
From: Michael Von_Kopp_Ostrowski       Base   : Pascal Echo
To  : Gerald Gutierrez                 Refer #: None
Subj: SB Port ?                        Replies: None
Stat: Sent                             Origin : 31 Jul 92  12:14:00

 > Why waste money when I don't have to ? I have the other routines .. I
 > simply need one that tells me where the base port is.

Here is the solution to your problem.

By the way, how can I get the Interupt Channel (IRQ) which is used
by the Soundblaster ???


----------------------------------------------------------------------

{$F+}

function IdentifySB : word;
var c : integer; iport : word;
begin
  iport:=0;
  asm
    mov  cx,6
    mov  dx,$210
  @@2494:
    push dx
    push cx
    call @@24C2
    pop  cx
    pop  dx
    je   @@24a4
    add  dx,$10
    loop @@2494
    mov  iport,0
    jmp  @@exit
  @@24a4:
    mov  iport,dx
    jmp  @@exit

  @@24c2:
    add  dx,6
    mov  al,1
    out  dx,al
    in   al,dx
    in   al,dx
    in   al,dx
    in   al,dx
    sub  al,al
    out  dx,al
    mov  bl,6
    sub  dx,6
  @@429:
    call @@24e1
    cmp  al,$AA
    je   @@24da
    dec  bl
    jne  @@429
    mov  ax,2
    or   ax,ax
    db   $c3 (* ret *)
  @@24da:
    sub  ax,ax
    or   ax,ax
    db   $c3  (* ret *)

  @@24e1:
    push cx
    push dx

    add  dl,$E
    mov  cx,$200
  @@403:
    in   al,dx
    or   al,al
    js   @@24f4
    loop @@403
    stc
    pop  dx
    pop  cx
    db  $c3  (* ret *)

  @@24f4:
    sub  dl,4
    in   al,dx
    pop  dx
    pop  cx
    clc
    db  $c3  (* ret *)
  @@exit:
  end;
  IdentifySB:=iport;
  if (iport=0) then exit else begin
    asm
      mov  cx,6
      mov  dx,iport
      call @@24C2
      jnb  @@24a4
      mov  iport,0
    @@24a4:
      jmp  @@exit

    @@24c2:
      add  dx,6
      mov  al,1
      out  dx,al
      mov  cx,$a
    @@24cb:
      loop @@24cb
      mov  al,0
      out  dx,al
      add  dx,6
      call @@24e1
      jnb  @@24da
      stc
      db   $c3 (* ret *)
    @@24da:
      mov  al,$d1
      out  dx,al
      call @@24e1
      db  $c3  (* ret *)

    @@24e1:
      mov  cx,$a
    @@24e4:
      push cx
      mov  cx,$FF
    @@24e8:
      in   al,dx
      rol  al,1
      jnb  @@24f4
      loop @@24e8
      pop  cx
      loop @@24e4
      stc
      db  $c3  (* ret *)
    @@24f4:
      pop  cx
      clc
      db  $c3  (* ret *)

    @@exit:
    end;
    if iport=0 then begin
      IdentifySB:=0;exit;
    end;
    iport:=iport+$C;
  end;
  IdentifySB:=iport;
end;
---------------------------------------------------------------------------

---
 * Origin: Point 10 of C.O.N. Project Cologne  *FRG* (2:242/512.10)



[Pascal Echo]
[336] Read (1-349, <CR>, ? = HELP) >> 